import java.awt.*;
import java.awt.event.*;


/**
 *
 * Beschreibung
 *
 * @version 1.0 vom 20.10.2008
 * @author
 */
public class GUIFahrschule extends Frame {

  // Anfang Attribute
  // View
  private Label lKennzeichen = new Label();
  private Label lKilometerstand = new Label();
  private Label lTankanzeige = new Label();
  private TextField tfKennzeichen = new TextField();
  private TextField tfKilometerstand = new TextField();
  private TextField tfTankanzeige = new TextField();
  private Button bFahren = new Button();
  private Button bTanken = new Button();
  private Button bBeenden = new Button();
  private TextField tfKilometer = new TextField();
  private Label lKilometer = new Label();
  private TextField tfLiter = new TextField();
  private Label lLiter = new Label();
  private Label lAuto = new Label();
  private Label lSchueler = new Label();
  private Label lName = new Label();
  private Label lTheoriestunden = new Label();
  private Label lPraxisstunden = new Label();
  private TextField tfSchuelerName = new TextField();
  private TextField tfSchuelerTheorie = new TextField();
  private TextField tfSchuelerPraxis = new TextField();
  private Button bPraxisstunde = new Button();
  private Button bTheoriestunde = new Button();
  private Button bTheoriepruefung = new Button();
  private Button bPraxispruefung = new Button();
  private Button bEinsteigen1 = new Button();
  private Label lPraxispruefung = new Label();
  private Label lTheoriepruefung = new Label();
  private TextField tfTheoriepruefung = new TextField();
  private TextField tfPraxispruefung = new TextField();
  private TextField tfAusgabe = new TextField();
  private Button bAussteigen = new Button();
  private Button bEinsteigen2 = new Button();

  // Model
  public Fahrschueler einFahrschueler = new Fahrschueler("Gerald");
  public Auto dasAuto1 = new Auto("DA-HT 456",  50, 8.8);
  public Auto dasAuto2 = new Auto("DA-RR 1090", 70, 7.3);
  public AutoCanvas AutoCanvas1 = new AutoCanvas(dasAuto1, "auto1.gif");
  public AutoCanvas AutoCanvas2 = new AutoCanvas(dasAuto2, "auto2.png");
  // Ende Attribute
  
  public GUIFahrschule(String title) {
    // Frame-Initialisierung
    super(title);
    addWindowListener(new WindowAdapter() {
        public void windowClosing(WindowEvent evt) {
          System.exit(0);
        }
      });

    int frameWidth = 627;
    int frameHeight = 391;
    setSize(frameWidth, frameHeight);

    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);

    Panel cp = new Panel(null);
    add(cp);
    // Anfang Komponenten
    lKennzeichen.setBounds(8, 40, 79, 16);
    lKennzeichen.setText("Kennzeichen:");
    lKennzeichen.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(lKennzeichen);
    lKilometerstand.setBounds(8, 72, 92, 16);
    lKilometerstand.setText("Kilometerstand:");
    lKilometerstand.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(lKilometerstand);
    lTankanzeige.setBounds(8, 104, 82, 16);
    lTankanzeige.setText("Tankanzeige:");
    lTankanzeige.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(lTankanzeige);
    tfKennzeichen.setBounds(120, 32, 121, 24);
    tfKennzeichen.setText("");
    tfKennzeichen.setEditable(false);
    cp.add(tfKennzeichen);
    tfKilometerstand.setBounds(120, 64, 121, 24);
    tfKilometerstand.setText("");
    tfKilometerstand.setEditable(false);
    cp.add(tfKilometerstand);
    tfTankanzeige.setBounds(120, 96, 121, 24);
    tfTankanzeige.setText("");
    tfTankanzeige.setEditable(false);
    cp.add(tfTankanzeige);
    bFahren.setBounds(120, 128, 123, 25);
    bFahren.setLabel("Fahren");
    bFahren.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          bFahren_ActionPerformed(evt);
        }
      });
    cp.add(bFahren);
    bTanken.setBounds(120, 160, 123, 25);
    bTanken.setLabel("Tanken");
    bTanken.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          bTanken_ActionPerformed(evt);
        }
      });
    cp.add(bTanken);
    bBeenden.setBounds(496, 224, 118, 25);
    bBeenden.setLabel("Beenden");
    bBeenden.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          bBeenden_ActionPerformed(evt);
        }
      });
    cp.add(bBeenden);
    tfKilometer.setBounds(8, 128, 41, 24);
    tfKilometer.setText("100");
    cp.add(tfKilometer);
    lKilometer.setBounds(56, 136, 26, 16);
    lKilometer.setText("km");
    lKilometer.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(lKilometer);
    tfLiter.setBounds(8, 160, 41, 24);
    tfLiter.setText("20");
    cp.add(tfLiter);
    lLiter.setBounds(56, 168, 33, 16);
    lLiter.setText("Liter");
    lLiter.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(lLiter);
    lAuto.setBounds(8, 8, 32, 16);
    lAuto.setText("Auto");
    lAuto.setFont(new Font("MS Sans Serif", Font.BOLD, 13));
    cp.add(lAuto);
    lSchueler.setBounds(256, 8, 82, 16);
    lSchueler.setText("Fahrschüler");
    lSchueler.setFont(new Font("MS Sans Serif", Font.BOLD, 13));
    cp.add(lSchueler);
    lName.setBounds(256, 40, 40, 16);
    lName.setText("Name:");
    lName.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(lName);
    lTheoriestunden.setBounds(256, 72, 97, 16);
    lTheoriestunden.setText("Theoriestunden:");
    lTheoriestunden.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(lTheoriestunden);
    lPraxisstunden.setBounds(256, 104, 87, 16);
    lPraxisstunden.setText("Praxisstunden:");
    lPraxisstunden.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(lPraxisstunden);
    tfSchuelerName.setBounds(368, 32, 121, 24);
    tfSchuelerName.setText("Gerald");
    tfSchuelerName.setEditable(false);
    cp.add(tfSchuelerName);
    tfSchuelerTheorie.setBounds(368, 64, 121, 24);
    tfSchuelerTheorie.setText("");
    tfSchuelerTheorie.setEditable(false);
    cp.add(tfSchuelerTheorie);
    tfSchuelerPraxis.setBounds(368, 96, 121, 24);
    tfSchuelerPraxis.setText("");
    tfSchuelerPraxis.setEditable(false);
    cp.add(tfSchuelerPraxis);
    bPraxisstunde.setBounds(496, 96, 115, 25);
    bPraxisstunde.setLabel("Praxisstunde");
    bPraxisstunde.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          bPraxisstunde_ActionPerformed(evt);
        }
      });
    cp.add(bPraxisstunde);
    bTheoriestunde.setBounds(496, 64, 115, 25);
    bTheoriestunde.setLabel("Theoriestunde");
    bTheoriestunde.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          bTheoriestunde_ActionPerformed(evt);
        }
      });
    cp.add(bTheoriestunde);
    bTheoriepruefung.setBounds(496, 128, 115, 25);
    bTheoriepruefung.setLabel("Theorieprüfung");
    bTheoriepruefung.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          bTheoriepruefung_ActionPerformed(evt);
        }
      });
    cp.add(bTheoriepruefung);
    bPraxispruefung.setBounds(496, 160, 115, 25);
    bPraxispruefung.setLabel("Praxisprüfung");
    bPraxispruefung.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          bPraxispruefung_ActionPerformed(evt);
        }
      });
    cp.add(bPraxispruefung);
    bEinsteigen1.setBounds(120, 224, 130, 25);
    bEinsteigen1.setLabel("In Auto 1 einsteigen!");
    bEinsteigen1.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          bEinsteigen1_ActionPerformed(evt);
        }
      });
    cp.add(bEinsteigen1);
    lPraxispruefung.setBounds(256, 168, 84, 16);
    lPraxispruefung.setText("Praxisprüfung:");
    lPraxispruefung.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(lPraxispruefung);
    lTheoriepruefung.setBounds(256, 136, 94, 16);
    lTheoriepruefung.setText("Theorieprüfung:");
    lTheoriepruefung.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(lTheoriepruefung);
    tfTheoriepruefung.setBounds(368, 128, 121, 24);
    tfTheoriepruefung.setText("nein");
    tfTheoriepruefung.setEditable(false);
    cp.add(tfTheoriepruefung);
    tfPraxispruefung.setBounds(368, 160, 121, 24);
    tfPraxispruefung.setText("nein");
    tfPraxispruefung.setEditable(false);
    cp.add(tfPraxispruefung);
    bAussteigen.setBounds(392, 224, 102, 25);
    bAussteigen.setLabel("Aussteigen");
    bAussteigen.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          bAussteigen_ActionPerformed(evt);
        }
      });
    cp.add(bAussteigen);
    bEinsteigen2.setBounds(256, 224, 130, 25);
    bEinsteigen2.setLabel("In Auto 2 einsteigen!");
    bEinsteigen2.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          bEinsteigen2_ActionPerformed(evt);
        }
      });
    cp.add(bEinsteigen2);
    tfAusgabe.setBounds(120, 192, 489, 24);
    tfAusgabe.setText("");
    cp.add(tfAusgabe);
    AutoCanvas1.setBounds(8, 264, 601, 41);
    cp.add(AutoCanvas1);
    AutoCanvas2.setBounds(8, 312, 601, 41);
    cp.add(AutoCanvas2);
    // Ende Komponenten
    setResizable(false);
    setVisible(true);
  }

  // Anfang Methoden
  private void showView() {
    if (einFahrschueler.getAuto() != null) {
      Auto dasAuto = einFahrschueler.getAuto();
      tfKennzeichen.setText(dasAuto.getKennzeichen());
      tfKilometerstand.setText(Double.toString(dasAuto.getKilometerstand()));
      tfTankanzeige.setText("" + dasAuto.getTankinhalt());
    } else {
      tfKennzeichen.setText("");
      tfKilometerstand.setText("");
      tfTankanzeige.setText("");
    }
    tfSchuelerName.setText(einFahrschueler.getName());
    tfSchuelerTheorie.setText(Integer.toString(einFahrschueler.getTheorieStunden()));
    tfSchuelerPraxis.setText("" + einFahrschueler.getPraxisStunden());
  }
  
  public void ausgabe(String s) {
    tfAusgabe.setText(s);
  }

  // Anfang Ereignisprozeduren
  public void bFahren_ActionPerformed(ActionEvent evt) {
    double Strecke;
    double Kilometer;
    if (einFahrschueler.getAuto() == null) {
      ausgabe("Ohne Fahrer?");
      return;
    }
    try {
      Kilometer = Double.parseDouble(tfKilometer.getText());
    } catch (Exception e) {
      ausgabe("Bitte Wert vom Typ double eingeben.");
      return;
    }
    Strecke = einFahrschueler.getAuto().Fahren(Kilometer);
    if (Strecke != Kilometer) {
      ausgabe("Konnte nur " + Strecke + " km fahren - Tank leer!");
    }
    showView();
    AutoCanvas1.repaint();
    AutoCanvas2.repaint();
  }

  public void bTanken_ActionPerformed(ActionEvent evt) {
    double Liter;
    double Füllung;
    if (einFahrschueler.getAuto() == null) {
      ausgabe("Ohne Fahrer?");
      return;
    }
    try {
      Liter = Double.parseDouble(tfLiter.getText());
    } catch (Exception e) {
      ausgabe("Bitte Wert vom Typ double eingeben.");
      return;
    }
    Füllung = einFahrschueler.getAuto().Tanken(Liter);
    if (Füllung != Liter) {
      ausgabe("Konnte nur " + Füllung + " l tanken - Tank voll");
    }
    showView();
  }

  public void bPraxisstunde_ActionPerformed(ActionEvent evt) {
    einFahrschueler.PraxisStunde();
    showView();
  }

  public void bTheoriestunde_ActionPerformed(ActionEvent evt) {
    einFahrschueler.TheorieStunde();
    showView();
  }

  public void bTheoriepruefung_ActionPerformed(ActionEvent evt) {
    if (einFahrschueler.TheorieBestanden()) {
      tfTheoriepruefung.setText("ja");
      ausgabe("Theorieprüfung bestanden!");
    } else {
      ausgabe("Konnte Theorieprüfung nicht absolvieren.");
    }
  }

  public void bPraxispruefung_ActionPerformed(ActionEvent evt) {
    if (einFahrschueler.PraxisBestanden()) {
      tfPraxispruefung.setText("ja");
      ausgabe("Praxisprüfung bestanden!");
    } else {
      ausgabe("Konnte Praxisprüfung nicht absolvieren.");
    }
  }

  public void bEinsteigen1_ActionPerformed(ActionEvent evt) {
    if (!einFahrschueler.Einsteigen(dasAuto1)) {
      ausgabe("Konnte nicht in Auto 1 einsteigen!");
    }
    showView();
  }

  public void bEinsteigen2_ActionPerformed(ActionEvent evt) {
    if (!einFahrschueler.Einsteigen(dasAuto2)) {
      ausgabe("Konnte nicht in Auto 2 einsteigen!");
    }
    showView();
  }

  public void bAussteigen_ActionPerformed(ActionEvent evt) {
    if (!einFahrschueler.Aussteigen()) {
      ausgabe("Konnte nicht aussteigen!");
    }
    showView();
  }
  
  public void bBeenden_ActionPerformed(ActionEvent evt) {
    System.exit(0);
  }

  public static void main(String[] args) {
    new GUIFahrschule("GUIFahrschule");
  }

  // Ende Methoden
}
